<script setup lang="ts">
import { nextTick, onMounted, ref, watch } from 'vue'
import type { VForm } from 'vuetify/components'
import type { Ingredient } from '@/types/Ingredient'

function printStockCheck() {
    const printContent = document.getElementById('stock-check-table');

    if (printContent) {
        const originalContents = document.body.innerHTML;
        const popupWin = window.open('', '_blank');

        if (popupWin) {
            popupWin.document.open();
            popupWin.document.write(`
      <html>
          <head>
            <title>Stock Check</title>
            <style>
              body {
                background-color: #f5f5f5; 
                color: #3e2723; 
                font-family: 'Arial', sans-serif; 
              }
              table {
                width: 100%;
                border-collapse: collapse;
                margin-bottom: 20px;
                background-color: #fff; 
              }
              th, td {
                border: 1px solid #ddd;
                padding: 8px;
                text-align: left;
              }
              th {
                background-color: #795548; 
                color: #fff; 
              }
            </style>
          </head>
          <body onload="window.print(); window.onafterprint = function() { window.close(); }">
            <table>
              <thead>
                <tr>
                  <th>Id</th>
                  <th>Ingredient ID</th>
                  <th>Ingredient Name</th>
                  <th>Minimum</th>
                  <th>Balance</th>
                  <th>Price (Bath)</th>
                  <th>Balance (Now)</th>
                </tr>
              </thead>
              <tbody>
                ${printContent.querySelector('tbody').innerHTML}
              </tbody>
            </table>
          </body>
        </html>
      `);
            popupWin.document.close();
        } else {
            alert('Popup blocked. Please allow popups for this website.');
        }
        popupWin.onafterprint = () => {
            document.body.innerHTML = originalContents;
            setTimeout(() => {
                popupWin.close();
                location.reload();
            }, 100);
        };
    } else {
        alert('Table content not found.');
    }

}

const headers = [
    {
        title: 'Id',
        key: 'id',
        value: 'id',
        align: 'start'
    },
    {
        title: 'Ingredient ID',
        key: 'Ingredient ID',
        value: 'IngredientID',
        align: 'start'
    },
    {
        title: 'Ingredient Name',
        key: 'Ingredient Name',
        value: 'IngredientName',
        align: 'start'
    },
    {
        title: 'Minimum',
        key: 'Minimum',
        value: 'Minimum',
        align: 'start'
    },
    {
        title: 'Balance',
        key: 'Balance',
        value: 'Balance',
        align: 'start'
    },
    {
        title: 'Price (Bath)',
        key: 'Price',
        value: 'Price',
        align: 'start'
    },
    { title: 'Actions', key: 'actions', sortable: false }
]

const form = ref(false)
const refForm = ref<VForm | null>(null)
const dialog = ref(false)
const dialogDelete = ref(false)
const loading0 = ref(false)
const initialIngredient: Ingredient = {
    id: -1,
    IngredientID: '',
    IngredientName: '',
    Minimum: 0,
    Balance: 0,
    Price: 0
}

const editedIngredient = ref<Ingredient>(JSON.parse(JSON.stringify(initialIngredient)))
const ingredients = ref<Ingredient[]>([])
let editedIndex = -1
let lastId = 4
function onSubmit() { }
function closeDelete() {
    dialogDelete.value = false
    nextTick(() => {
        editedIngredient.value = Object.assign({}, initialIngredient)
    })
}
function deleteItemConfirm() {
    //Delete item from list
    ingredients.value.splice(editedIndex, 1)
    editedIngredient.value.id = lastId--
    closeDelete()
}
function editItem(item: Ingredient) {
    editedIndex = ingredients.value.indexOf(item)
    editedIngredient.value = Object.assign({}, item)
    dialog.value = true
}
function deleteItem(item: Ingredient) {
    editedIndex = ingredients.value.indexOf(item)
    editedIngredient.value = Object.assign({}, item)
    dialogDelete.value = true
    editedIndex = -1
}
function closeDialog() {
    dialog.value = false
    nextTick(() => {
        editedIngredient.value = Object.assign({}, initialIngredient)
        editedIndex = -1
    })
}
async function save() {
    const { valid } = await refForm.value!.validate()

    if (!valid) return

    if (editedIndex > -1) {
        Object.assign(ingredients.value[editedIndex], editedIngredient.value)
    } else {
        editedIngredient.value.id = lastId++
        ingredients.value.push(editedIngredient.value)
    }

    closeDialog()
}
function initialize() {
    ingredients.value = [
        {
            id: 1,
            IngredientID: 'P001',
            IngredientName: 'น้ำตาล(Sugar)',
            Minimum: 10,
            Balance: 25,
            Price: 40
        },
        {
            id: 2,
            IngredientID: 'P002',
            IngredientName: 'วิปครีม(whipped cream)',
            Minimum: 5,
            Balance: 12,
            Price: 289
        },
        {
            id: 3,
            IngredientID: 'P003',
            IngredientName: 'ผงชาเขียว(matcha powder)',
            Minimum: 10,
            Balance: 16,
            Price: 70
        },
      {
        id: 4,
        IngredientID: 'P004',
        IngredientName: 'กาแฟสด(Fresh Coffee)',
        Minimum: 8,
        Balance: 20,
        Price: 90
      },
      {
        id: 5,
        IngredientID: 'P005',
        IngredientName: 'น้ำมะนาว(Lime Juice)',
        Minimum: 12,
        Balance: 18,
        Price: 25
      },
      {
        id: 6,
        IngredientID: 'P006',
        IngredientName: 'นมถั่วเหลือง(Soy Milk)',
        Minimum: 15,
        Balance: 25,
        Price: 60
      },
      {
        id: 7,
        IngredientID: 'P007',
        IngredientName: 'มะม่วงสด(Fresh Mango)',
        Minimum: 10,
        Balance: 15,
        Price: 120
      },
      {
        id: 8,
        IngredientID: 'P008',
        IngredientName: 'น้ำมันมะพร้าว(Coconut Oil)',
        Minimum: 5,
        Balance: 10,
        Price: 50
      },
      {
        id: 9,
        IngredientID: 'P009',
        IngredientName: 'เกลือ(Salt)',
        Minimum: 3,
        Balance: 8,
        Price: 15
      },
      {
        id: 10,
        IngredientID: 'P010',
        IngredientName: 'พริกไทยดำ(Black Pepper)',
        Minimum: 2,
        Balance: 5,
        Price: 18
      },
      {
        id: 11,
        IngredientID: 'P011',
        IngredientName: 'น้ำมันกระเทียม(Garlic Oil)',
        Minimum: 5,
        Balance: 12,
        Price: 30
      },
      {
        id: 12,
        IngredientID: 'P012',
        IngredientName: 'ไข่ไก่(Egg)',
        Minimum: 20,
        Balance: 30,
        Price: 6
      },
      {
        id: 13,
        IngredientID: 'P013',
        IngredientName: 'มิ้นท์เซอร์เวอร์(Mint Server)',
        Minimum: 3,
        Balance: 8,
        Price: 40
      },
      {
        id: 14,
        IngredientID: 'P014',
        IngredientName: 'ถั่วเขียว(Green Beans)',
        Minimum: 10,
        Balance: 18,
        Price: 35
      }
    ]
}
onMounted(() => {
    initialize()
})

const FakeAPI = {
    async fetch({
        page,
        itemsPerPage,
        sortBy,
        search
    }: {
        page: number
        itemsPerPage: number
        sortBy: { key: string; order: string }[]
        search: { name?: string; Balance?: string }
    }) {
        return new Promise((resolve) => {
            setTimeout(() => {
                const start = (page - 1) * itemsPerPage
                const end = start + itemsPerPage
                const items = ingredients.value.slice().filter((item) => {
                    if (
                        search.name &&
                        !item.IngredientName.toLowerCase().includes(search.name.toLowerCase())
                    ) {
                        return false
                    }
                    if (search.Balance && (item.Balance <= Number(search.Balance))) {
                        return false
                    }
                    return true
                })

                if (sortBy.length) {
                    const sortKey = sortBy[0].key
                    const sortOrder = sortBy[0].order
                    items.sort((a, b) => {
                        const aValue = a[sortKey]
                        const bValue = b[sortKey]
                        return sortOrder === 'desc' ? bValue - aValue : aValue - bValue
                    })
                }

                const paginated = items.slice(start, end)

                resolve({ items: paginated, total: items.length })
            }, 500)
        })
    }
}

const itemsPerPage = ref(5)
const serverItems = ref([])
const loading = ref(true)
const totalItems = ref(0)
const name = ref('')
const Balance = ref('')
const search = ref('')

watch([name, Balance], () => {
    search.value = String(Date.now())
})

const loadItems = ({
    page,
    itemsPerPage,
    sortBy
}: {
    page: number
    itemsPerPage: number
    sortBy: { key: string; order: string }[]
}) => {
    loading.value = true
    initialize()
    FakeAPI.fetch({
        page,
        itemsPerPage,
        sortBy,
        search: { name: name.value, Balance: Balance.value }
    }).then(({ items, total }) => {
        ingredients.value = items
        totalItems.value = total
        loading.value = false
    })
    initialize()
}
</script>
<template>
    <div style="background-color: rgba(82, 72, 54, 0.822);">
        <v-toolbar-title
            style="font-size: 20pt; margin-left: 20px; padding-top: 20px; color: rgb(255, 255, 255);"><v-icon>mdi
                mdi-cart-outline </v-icon>Stock </v-toolbar-title><br>
        <v-row>
            <v-col>
                <tr>
                    <td>
                        <v-text-field v-model="name" hide-details placeholder="Search name..." class="ma-2"
                            density="compact" style="width: 300px" variant="solo-inverted"></v-text-field>
                    </td>
                    <td>
                        <v-text-field v-model="Balance" hide-details placeholder="Seacrh by Balance" type="number"
                            class="ma-2" density="compact" variant="solo-inverted"></v-text-field>
                    </td>
                    <v-btn style="margin-top: -30px; margin-left: 20px" color="primary" @click="initialize"><v-icon>mdi
                            mdi-restart</v-icon></v-btn>
                </tr>
            </v-col>
            <v-col cols="2.5" style="margin-top: 13px;"><v-btn @click="printStockCheck" color="primary"><v-icon >mdi-printer</v-icon>Check</v-btn></v-col>
            <v-col cols="3" style="margin-top: 10px">
                <v-dialog v-model="dialog" persistent width="1024">
                    <template v-slot:activator="{ props }">
                        <v-btn color="white" v-bind="props" variant="outlined" style="margin-top: 2px; margin-left: 50px">
                            <v-icon style="margin-right: 8px;">mdi-package-variant-plus</v-icon> New Ingredient
                        </v-btn>
                    </template>    
                    <v-card>
                        <v-card-title>
                            <span class="text-h5">Ingredient Info</span>
                        </v-card-title>
                        <v-card-text>
                            <v-form ref="refForm" v-model="form" @submit.prevent="onSubmit">
                                <v-container>
                                    <v-row>
                                        <v-col cols="12" sm="12" md="4">
                                            <v-text-field v-model="editedIngredient.IngredientID" :readonly="loading"
                                                :rules="[(v) => !!v || 'Field is required']" class="mb-2" clearable
                                                label="Ingredient ID"></v-text-field>
                                        </v-col>
                                        <v-col cols="12" sm="12" md="4">
                                            <v-text-field v-model="editedIngredient.IngredientName" :readonly="loading"
                                                :rules="[(v) => !!v || 'Field is required']" class="mb-2" clearable
                                                label="Ingredient Name"></v-text-field>
                                        </v-col>
                                        <v-col cols="12" sm="12" md="4">
                                            <v-text-field v-model="editedIngredient.Minimum" :readonly="loading"
                                                :rules="[(v) => !!v || 'Field is required']" clearable label="Minimum"
                                                placeholder="Enter your Minimum"></v-text-field>
                                        </v-col>
                                        <v-col cols="12" sm="6">
                                            <v-text-field label="Balance" v-model="editedIngredient.Balance"></v-text-field>
                                        </v-col>
                                        <v-col cols="12" sm="6">
                                            <v-text-field v-model="editedIngredient.Price" label="Price" multiple
                                                :return-object="false"></v-text-field>
                                        </v-col>
                                    </v-row>
                                </v-container>
                            </v-form>
                            <small>*indicates required field</small>
                        </v-card-text>
                        <v-card-actions>
                            <v-spacer></v-spacer>
                            <v-btn color="blue-darken-1" variant="text" @click="closeDialog()"> Close </v-btn>
                            <v-btn color="blue-darken-1" variant="text" @click="save()"> Save </v-btn>
                        </v-card-actions>
                    </v-card>
                </v-dialog>
                <!-- Delete Dialog -->
                <v-dialog v-model="dialogDelete" max-width="500px">
                    <v-card>
                        <v-card-title class="text-h5">Are you sure you want to delete this item?</v-card-title>
                        <v-card-actions>
                            <v-spacer></v-spacer>
                            <v-btn color="blue-darken-1" variant="text" @click="closeDelete">Cancel</v-btn>
                            <v-btn color="blue-darken-1" variant="text" @click="deleteItemConfirm">OK</v-btn>
                            <v-spacer></v-spacer>
                        </v-card-actions>
                    </v-card>
                </v-dialog>
            </v-col>
        </v-row>
    </div>
    <br>
    <v-data-table-server v-model:items-per-page="itemsPerPage" :search="search" :headers="headers"
        :items-length="totalItems" :items="ingredients" :loading="loading" item-value="name" @update:options="loadItems" id="stock-check-table"
        class="custom-table-style">
        <template v-slot:[`item.actions`]="{ item }">
            <v-icon size="small" class="me-2 custom-edit-icon" @click="editItem(item)">mdi-pencil</v-icon>
            <v-icon size="small" class="custom-delete-icon" @click="deleteItem(item)">mdi-delete</v-icon>  
        </template>
    </v-data-table-server>
</template>
<style scoped>
.custom-table-style {
    background-color: rgba(202, 174, 123, 0.582);
    border-radius: 10px;
}

.custom-edit-icon {
    color: #000000;
}

.custom-delete-icon {
    color: #000000;
}
</style>